"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.dataArrayFromSnap=dataArrayFromSnap;exports.parseFixturePath=parseFixturePath;exports.getEnvPrefix=getEnvPrefix;exports.envVarBasedOnCIEnv=envVarBasedOnCIEnv;exports.getServiceAccount=getServiceAccount;exports.slashPathToFirestoreRef=slashPathToFirestoreRef;exports.getArgsString=getArgsString;exports.addDefaultArgs=addDefaultArgs;var _isString2=_interopRequireDefault(require("lodash/isString"));var _path=_interopRequireDefault(require("path"));var _fs=_interopRequireDefault(require("fs"));var _constants=require("./constants");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function dataArrayFromSnap(snap){const data=[];if(snap.data&&snap.exists){data.push({id:snap.id,data:snap.data()})}else if(snap.forEach){snap.forEach(doc=>{data.push({id:doc.id,data:doc.data()||doc})})}return data}function parseFixturePath(unparsed){if((0,_isString2.default)(unparsed)){try{return JSON.parse(unparsed)}catch(err){console.log("Error parsing fixture to JSON:",err);return unparsed}}return unparsed}function getEnvironmentSlug(){return process.env.CI_ENVIRONMENT_SLUG||"stage"}function getEnvPrefix(){const envSlug=getEnvironmentSlug();return`${envSlug.toUpperCase()}_`}function getServiceAccountPath(){return _path.default.join(_constants.DEFAULT_BASE_PATH,"serviceAccount.json")}function envVarBasedOnCIEnv(varNameRoot){const prefix=getEnvPrefix();const combined=`${prefix}${varNameRoot}`;const localTestConfigPath=_path.default.join(process.cwd(),_constants.DEFAULT_TEST_FOLDER_PATH,"config.json");if(_fs.default.existsSync(localTestConfigPath)){const configObj=require(localTestConfigPath);return configObj[combined]||configObj[varNameRoot]}const fallbackConfigPath=_path.default.join(process.cwd(),_constants.FALLBACK_TEST_FOLDER_PATH,"config.json");if(_fs.default.existsSync(fallbackConfigPath)){const configObj=require(fallbackConfigPath);return configObj[combined]||configObj[varNameRoot]}return process.env[combined]||process.env[varNameRoot]}function getParsedEnvVar(varNameRoot){const val=envVarBasedOnCIEnv(varNameRoot);const prefix=getEnvPrefix();const combinedVar=`${prefix}${varNameRoot}`;if(!val){console.error(`${combinedVar} not found, make sure it is set within environment vars`)}try{if((0,_isString2.default)(val)){return JSON.parse(val)}return val}catch(err){console.error(`Error parsing ${combinedVar}`);return val}}function getServiceAccount(){const serviceAccountPath=getServiceAccountPath();if(_fs.default.existsSync(serviceAccountPath)){return require(serviceAccountPath)}return{type:"service_account",project_id:envVarBasedOnCIEnv("FIREBASE_PROJECT_ID"),private_key_id:envVarBasedOnCIEnv("FIREBASE_PRIVATE_KEY_ID"),private_key:getParsedEnvVar("FIREBASE_PRIVATE_KEY"),client_email:envVarBasedOnCIEnv("FIREBASE_CLIENT_EMAIL"),client_id:envVarBasedOnCIEnv("FIREBASE_CLIENT_ID"),auth_uri:"https://accounts.google.com/o/oauth2/auth",token_uri:"https://accounts.google.com/o/oauth2/token",auth_provider_x509_cert_url:"https://www.googleapis.com/oauth2/v1/certs",client_x509_cert_url:envVarBasedOnCIEnv("FIREBASE_CERT_URL")}}function slashPathToFirestoreRef(firestoreInstance,slashPath,options={}){let ref=firestoreInstance;const srcPathArr=slashPath.split("/");srcPathArr.forEach(pathSegment=>{if(ref.collection){ref=ref.collection(pathSegment)}else if(ref.doc){ref=ref.doc(pathSegment)}else{throw new Error(`Invalid slash path: ${slashPath}`)}});if(options.limit&&typeof ref.limit==="function"){ref=ref.limit(options.limit)}return ref}function getArgsString(args){return args&&args.length?` ${args.join(" ")}`:""}function addDefaultArgs(Cypress,args,opts={}){const _opts$disableYes=opts.disableYes,disableYes=_opts$disableYes===void 0?false:_opts$disableYes;const newArgs=[...args];const projectId=Cypress.env("firebaseProjectId")||Cypress.env("FIREBASE_PROJECT_ID")||Cypress.env("STAGE_FIREBASE_PROJECT_ID");if(!newArgs.includes("-P")||!newArgs.includes(projectId)){newArgs.push("-P");newArgs.push(projectId)}if(!disableYes&&!newArgs.includes(_constants.FIREBASE_TOOLS_YES_ARGUMENT)){newArgs.push(_constants.FIREBASE_TOOLS_YES_ARGUMENT)}return newArgs}